-- Greg Stitt
-- University of Florida

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.sum_pkg.all;

entity sum_tb is
end sum_tb;


architecture TB of sum_tb is

  signal inputs : input_array;
  signal output : std_logic_vector(7 downto 0);

begin  -- TB

  UUT : entity work.sum
    port map (
      inputs => inputs,
      output => output);

  process
  begin
    -- test all input combinations
    for i in 0 to 2**8-1 loop
      for j in 0 to 2**8-1 loop
        for k in 0 to 2**8-1 loop
          for l in 0 to 2**8-1 loop

            inputs(0) <= std_logic_vector(to_unsigned(i,8));
            inputs(1) <= std_logic_vector(to_unsigned(j,8));
            inputs(2) <= std_logic_vector(to_unsigned(k,8));
            inputs(3) <= std_logic_vector(to_unsigned(l,8));
            wait for 10 ns;

          end loop;  -- l
        end loop;  -- k
      end loop;  -- j
    end loop;  -- i
    wait;

  end process;

end TB;
